<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="arName" label="ar内容名称">
                <el-input v-model="formData.arName" :disabled="'arName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="arType" label="ar类型">
                <template>
                    <el-select v-model="formData.arType" clearable placeholder="请选择" :disabled="'arType'==subColumn">
                        <el-option v-for="item in arTypeOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item prop="activationMode" label="激活方式">
                <template>
                    <el-select v-model="formData.activationMode" clearable placeholder="请选择" :disabled="'activationMode'==subColumn">
                        <el-option v-for="item in activationModeOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark" :disabled="'remark'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="templateId" label="模板">
                <el-input v-model="formData.templateId" :disabled="'templateId'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="templateAimId" label="模板点标">
                <el-input v-model="formData.templateAimId" :disabled="'templateAimId'==subColumn"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.column) {
            this.subColumn = this.$route.query.column.split(',')[1];
            this.subValue = this.$route.query.column.split(',')[0];
        }

        if (this.$route.query.id) {
            this.$http.get({
                url: '/aimTemplateAr/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {


                    this.formData = res.data;

                    if (this.$route.query.column) {
                        this.formData[this.subColumn] = this.subValue;
                    }
                }
            })
        } else {
            if (this.$route.query.column) {
                this.formData[this.subColumn] = this.subValue;
            }
        }


        this.$http.get({
            url: '/arContentType/all'
        }).then(res => {
            if (res.success) {

                if (res.data.length > 0) {
                    res.data.forEach(item => {
                        this.arTypeOptions.push({ label: item.typeName, value: String(item.id) });
                    })
                }
            }
        });

    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                arName:
                    [
                        { required: true, message: '请输入 ar内容名称', trigger: 'blur' },
                    ],
            },
            arTypeOptions: [],
            activationModeOptions: [{
                value: '1',
                label: '直接出现'
            }, {
                value: '2',
                label: '渐变'
            }, {
                value: '3',
                label: '由上向下飞入'
            }, {
                value: '4',
                label: '由左至右飞入'
            }, {
                value: '5',
                label: '由右至左飞入'
            }],
            subColumn: '',
            subValue: '',
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));
            this.$http.post({
                url: this.formData.id ? '/aimTemplateAr/update' : '/aimTemplateAr/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/aimTemplateAr/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
    }
}
</script>
<style lang="less" scoped>
</style>
